SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Proc SybRep2PB (
@rptid   int ,
@lytid   int ,
@lines   int )
As
Begin
declare @work       varchar(355),
        @name       varchar(30),
        @ypos       int,
        @pypos      int,
        @cpos       char(2),
        @fmtinfo    varchar(255),
        @fldid      int,
        @what       varchar(255),
        @quot1      int,
        @quot2      int

create table #t1
( work  varchar(355)
)

    select @pypos = -1

    declare c1 cursor
    for select name,
               ypos,
               fmtinfo,
               fldid
        from syb_fields
        where rptid = @rptid
          and lytid = @lytid
        order by ypos, xpos

    open c1

    while 1=1
    begin
        fetch c1
         into @name,
              @ypos,
              @fmtinfo,
              @fldid

        if @@fetch_status != 0
            break

        if @pypos ! = @ypos
        begin
            if @pypos != -1
                insert into #t1
                values('FileWrite(li_OutFile,ls_MyLine)' + char(10))

            select @pypos = @pypos + 1

            while @pypos < @ypos
            begin
                select @cpos =substring(convert(varchar(3),101+@pypos),2,2)

                insert into #t1
                values('// Line ' + @cpos)

                insert into #t1
                values('ls_MyLine = " "')

                insert into #t1
                values('FileWrite(li_OutFile,ls_MyLine)' + char(10))

                select @pypos = @pypos + 1
            end

            select @pypos = @ypos

            select @cpos =substring(convert(varchar(3),101+@ypos),2,2)

            insert into #t1
            values('// Line ' + @cpos)

            insert into #t1
            values('ls_MyLine = " "')
        end

        if @name is null
        begin
            select @what = '""'

            select @quot1 = charindex('"',@fmtinfo)

            if @quot1 != 0
            begin
                select @quot2 = charindex('"',@fmtinfo,@quot1 + 1)

                if @quot2 != 0
                   select @what = substring(@fmtinfo,@quot1,@quot2 - @quot1 + 1)
            end

            select @work =
                    'ls_MyLine = f_InsStrInPos(ls_MyLine,' + @what + ',' +
                    ltrim(convert(varchar(3),xpos+1)) + ',' +
                    ltrim(convert(varchar(3),width)) + ',"L") // ' +
                    ltrim(convert(varchar(3),ypos+1)) + '  ' + substring(fmtinfo,1,1)
              from syb_fields
             where rptid = @rptid
               and lytid = @lytid
               and fldid = @fldid
        end
        else
            select @work =
                'ls_MyLine = f_InsStrInPos(ls_MyLine,' +
                    case substring(fmtinfo,1,1)
                      when 'R' then
                        'string(' + name + ',"#####.00")'
                      when 'N' then
                        'string(' + name + ',"######")'
                      when 'D' then
                        'string(' + name + ',"dd-MMM-yy")'
                      else name
                    end + ',' +
                ltrim(convert(varchar(3),xpos+1)) + ',' +
                ltrim(convert(varchar(3),width)) + ',"' +
                    case substring(fmtinfo,1,1)
                      when 'R' then 'R'
                      when 'N' then 'R'
                      else 'L'
                    end + '") // ' +
                ltrim(convert(varchar(3),ypos+1)) + '  ' + substring(fmtinfo,1,1)
              from syb_fields
             where rptid = @rptid
               and lytid = @lytid
               and fldid = @fldid

        insert into #t1
        values(@work)

    end

    if @pypos != -1
        insert into #t1
        values('FileWrite(li_OutFile,ls_MyLine)' + char(10))

    select @pypos = @pypos + 1

    while @pypos < @lines
    begin
        select @cpos =substring(convert(varchar(3),101+@pypos),2,2)

        insert into #t1
        values('// Line ' + @cpos)

        insert into #t1
        values('ls_MyLine = " "')

        insert into #t1
        values('FileWrite(li_OutFile,ls_MyLine)' + char(10))

        select @pypos = @pypos + 1
    end

    close c1

    deallocate c1

    Select work
      from #t1

    drop table #t1


End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

